
#include <stdio.h>
#include <math.h>

#define     PI      3.14159265359

/*  xǥ yǥ  ü */
typedef struct _point
{
    int x;
    int y;
}point;

/*  ȯϴ Լ*/
double RadianToDegree(double radian);

/*  ȯϴ Լ*/
double DegreeToRadian(double degree);

/*    ϴ Լ,  ȣ ȯϴ Լ*/
double AngleRadian(int dx, int dy);

/*    ϴ Լ,  60й ȯϴ Լ*/
double AngleDegree(int dx, int dy);

int main(void)
{
    point originPos = { 1, 1 };
    point destPos = { -1, -1 };
    
    int dx = destPos.x - originPos.x;
    int dy = destPos.y - originPos.y;

    double radian = AngleRadian(dx, dy);
    double degree = AngleDegree(dx, dy);

    printf("   (degree) : %.3lf\n", degree);
    printf("   (radian) : %.3lf\n", radian);

	return 0;
}

/*  ȯϴ Լ*/
double RadianToDegree(double radian)
{
	return (radian * 180.0) / (PI);
}

/*  ȯϴ Լ*/
double DegreeToRadian(double degree)
{
	return degree * PI / 180.0;
}

/*    ϴ Լ,  ȣ ȯϴ Լ*/
double AngleRadian(int dx, int dy)
{
    //  case1 
    if (dx == 0 && dy == 0)
        return 0;

    //  case2 
    if (dy == 0)
    {
        if (dx > 0) return 0;
        else return PI;
    }

    //  case3 
    if (dx == 0)
    {
        if (dy > 0) return (PI / 2);
        else return (PI / 2) * 3;
    }

    //  Ʒ if ~ lse case4 
    if (dx > 0)
    {
        //  1и
        if (dy > 0) return atan((double)dy / dx);
        //  4и
        else return atan((double)dy / dx) + (2 * PI);
    }
    //  2и 3и
    else
        return atan((double)dy / dx) + PI;
}

/*    ϴ Լ,  60й ȯϴ Լ*/
double AngleDegree(int dx, int dy)
{
    double radian;

    //  case1 
    if (dx == 0 && dy == 0)
        return 0;

    //  case2 
    if (dy == 0)
    {
        if (dx > 0) return 0;
        else return 180;
    }

    //  case3 
    if (dx == 0)
    {
        if (dy > 0) return (180.0 / 2.0);
        else return (180.0 / 2.0) * 3.0;
    }

    //  Ʒ if ~ lse case4 
    if (dx > 0)
    {
        //  1и
        if (dy > 0)
        {
            radian = atan((double)dy / dx);
            return RadianToDegree(radian);
        }
        //  4и
        else
        {
            radian = atan((double)dy / dx) + (2 * PI);
            return RadianToDegree(radian);
        }
    }
    //  2и 3и
    else
    {
        radian = atan((double)dy / dx) + PI;
        return RadianToDegree(radian);
    }
}

